extends CharacterBody2D
class_name CharacterBase

@export_group("Movement")
@export_range(1.0, 999999.9, 0.1) var speed: float = 100.0
@export_group("Combat")
@export var max_health: int = 100
@export_range(0, 999999, 1) var health: int = 100
@export var attack_power: int = 30
@export var KNOCKBACK_POWER: float = 40
@export var KNOCKBACK_RANDOMNESS: float = 50
@export_group("Animations")
@export var has_nsfw_animations = false

signal attacked
signal attack_did_hit(other: Area2D, power: int, attack_direction: Vector2)
signal got_hurt(new_health: int)
signal defeated

# Related nodes
@onready var anim_tree: AnimationTree = $AnimationTree
@onready var anim_playback: AnimationNodeStateMachinePlayback = anim_tree["parameters/playback"]

# Cutscene movement
var movement_scripted_by: CutsceneManager = null
var movement_scripted_target: Vector2
var movement_scripted_speed = 0.0

func set_animation_direction(direction: Vector2):
	pass
	
func _physics_process(_delta):
	move_and_slide()
	
func _on_animation_tree_animation_finished(anim_name):
	pass
	
func _on_enemy_attack_did_hit(other: Area2D, power: int, attack_direction: Vector2):
	pass
	
func _on_attackbox_area_entered(area: Area2D):
	pass

func _on_cutscene_issued_command(command: CutsceneCommand, manager: CutsceneManager):
	if command is MoveCharacterCommand:
		var target_character = manager.get_node(command.target_character)
		if target_character != self:
			return
		movement_scripted_target = command.target_vector if command.target_type == "Vector" else manager.get_node(command.target_node).global_position
		var approach_direction = global_position.direction_to(movement_scripted_target)
		set_animation_direction(approach_direction)
		var move_speed = speed if command.use_character_speed else command.speed
		velocity = move_speed * approach_direction
		movement_scripted_by = manager
		movement_scripted_speed = command.speed
		anim_playback.travel(command.animation_state)
